#ifndef _WIN
#define _WIN
///////////////////////

#include <windows.h>
#include "winseed.h"
#include "gdi.h"
#include "settings.h"

/////////////////////////////////////////////////////////
// WinSeedNXhAvP[VŗL̃NX
/////////////////////////////////////////////////////////

// ---------------------------------------------------
//	Q[NXAQ[Ƃɂ傢
// ---------------------------------------------------

class CGame : public CWinSeed
{
	public:
		void SetHelpName(LPSTR HelpName){ m_HelpName = HelpName; };

	protected:
	//vOl[
		LPSTR m_ProgName;
	//wvt@C̖O
		LPSTR m_HelpName;

	//̑AQ[ɕKvȃucǉB

};

/////////////////////////////////////////////////////////
// GameNXhAvP[VŗL̃NX
/////////////////////////////////////////////////////////
//======================================================================
//
//	CMainWindow
//		EChEAbZ[WnB
//
//======================================================================
class CMainWindow : public CGame
{
	private:
		CGdi *m_Gdi;

		UINT m_Tid;
		BOOL m_CloseFlag;
		int  m_mouseX, m_mouseY;
		BOOL m_FpsFlag;
		int  m_fps;
		int  m_FpsCount;

		void Init();
		BOOL OnCreate(HWND Hwnd , CREATESTRUCT FAR* lpCreateStruct);
		void OnClose (HWND Hwnd);
		void OnPaint (HWND Hwnd);
		void OnLButtonDown(HWND, BOOL d_click, int x, int y, UINT key);
		void OnLButtonUp(HWND Hwnd, int x, int y, UINT key);
		void OnRButtonDown(HWND Hwnd, BOOL d_click, C_INT x, C_INT y, UINT key);
		void OnRButtonUp(HWND Hwnd, int x, int y, UINT key);
		void OnMouseMove(HWND Hwnd, int x, int y, UINT key);
		void OnCommand(HWND Hwnd, int id, HWND hwndctl, UINT code);
		void OnTimer(HWND Hwnd, int id);

		void ChangeFullscreenMisc(void);
		void ChangeWindowMisc(void);

	public:
		CMainWindow(LPCSTR PName);
		long WndProc(UINT wMessage, WPARAM wParam, LPARAM lParam);
		BOOL SetGdiObject(CGdi *Gdi);
		BOOL IsClose(void)   { return m_CloseFlag; };
		BOOL GetMouseX(void) { return m_mouseX; };
		BOOL GetMouseY(void) { return m_mouseY; };

		void IncFpsCount(){ m_FpsCount++; };
		void FpsOn() { m_FpsFlag = TRUE; }
		void FpsOff(){ m_FpsFlag = FALSE; }
};

////////////////////////
#endif
