#ifndef _MCUBE
#define _MCUBE
//=========================================================================
//
//	MarchCube:}[`L[uNX
//		dʋԂ̔Zxzɂ
//		}[`L[uASYg
//		̉B
//
//=========================================================================
#include "3dmath.h"
#include "windows.h"
#include "array3d.h"

/***************************************************************************/
//NX̐錾

//==========================================================================
//	MarchCube:}[`L[uNX
//		dʔZx݁A
//		}[`L[usȂ
//==========================================================================
class CMcube
{
////////////////////////////////////////////////////////////////////////////
//JC^tFCX

	//RXgN^^fXgN^
	public:
		CMcube();
		~CMcube();

		//=================}[`L[uɂ|\z
		BOOL MarchCube();

		//=================}[`L[uԂ̐ݒ
		void SetCubeSpace(int iXdiv, int iYdiv, int iZdiv, int iGridSize);

		//=================GetnAϐɂȂDelete܂ꂽ獢̂ŁB
		VECTOR3 *GetVertexList() { return m_VertexList;    };
		VECTOR3 *GetGradient()   { return m_vGradient;      };
		int      GetVertexCount(){ return m_iVertexCounter; };
		PORY3   *GetPoly()       { return m_Poly;          };
		int      GetPoryCounter(){ return m_iPoryCounter;   };


////////////////////////////////////////////////////////////////////////////
//pJC^tFCX
	protected:
		static C_FLOAT ISO;//===========AC\ilj
		int m_XDIV, m_YDIV, m_ZDIV, m_GRID_SIZE;//======}[`L[uԂ̑傫

		//float *fDisp;//=======MarchCubeԂ̔Zx\
		CArray3D<float> m_fDisp;
		CArray3D<float> m_blFlag;

////////////////////////////////////////////////////////////////////////////
//JC^tFCX
	private:
		void VertexInterp( 
			C_FLOAT isolevel, 
			VECTOR3 &vVect, 
			VECTOR3 &vNormal, 
			C_VECTOR3 &p1,  
			C_VECTOR3 &p2,
			C_VECTOR3 &v1, 
			C_VECTOR3 &v2, 
			C_FLOAT valp1, 
			C_FLOAT valp2);

		C3dmath m_Vcalk;//==========RcvZIuWFNg

		BOOL m_blSetupFlag;//=====tO

		//=================dʋԂZoꂽ_i[ꏊ(newĎg)
		VECTOR3 *m_VertexList;//_
		VECTOR3 *m_vGradient;//@
		int m_iVertexCounter;

		//==================|S
		PORY3 *m_Poly;//|
		int m_iPoryCounter;
};


////////////////////////
#endif
