#include "objecter.h"
//=========================================================================
//IuWFN^[
//]Ƃړz
//Ƃ肠A
//=========================================================================
CObjecter :: CObjecter()
{
	m_MakeObjectFlag = FALSE;
}

CObjecter :: ~CObjecter()
{
	if(m_MakeObjectFlag)
	{
		delete [] m_ObjectVertex;
		delete [] m_ObjectGradient;
		delete [] m_ObjectPoly;
	}
}

void CObjecter :: MakeObject(C_VECTOR3 *lpvVertex, C_VECTOR3 *lpvGradient,
	int iVertexCount, C_PORY3 *lpiPoly, int iPolygonCount)
{
	int i;

	m_ObjectVertexCount = iVertexCount;
	m_ObjectPolyCount   = iPolygonCount;

	m_ObjectVertex     = new VECTOR3[m_ObjectVertexCount];
	m_ObjectGradient   = new VECTOR3[m_ObjectVertexCount];
	m_ObjectPoly       = new   PORY3[m_ObjectPolyCount];

	for(i=0 ; i<m_ObjectVertexCount ;i++)
	{
		m_ObjectVertex[i]   = lpvVertex[i];
		m_ObjectGradient[i] = lpvGradient[i];
	}

	for(i=0 ; i<m_ObjectPolyCount ;i++)
	{
		m_ObjectPoly[i] = lpiPoly[i];
	}

	m_MakeObjectFlag = TRUE;
}

void CObjecter :: Rotate(float Head, float Pich, float Bank)
{
	Vcalk.MakeRotateMatrix(&m_RotateMatrix, Head, Pich, Bank);
}

//zgׂ͂ẴIuWFNg̒_܂Ƃ߂āA
//ŁA_[ɓn񂾂ǁ[B
void CObjecter :: Render(CRender &RenderEngine)
{
	int i,j;

	VECTOR3 *OutputVertex   = new VECTOR3[m_ObjectVertexCount];
	VECTOR3 *OutputGradient = new VECTOR3[m_ObjectVertexCount];

	for(i=0 ; i<m_ObjectVertexCount ;i++)
	{
		Vcalk.Multiply(&OutputVertex[i], m_ObjectVertex[i], m_RotateMatrix);
		Vcalk.Multiply(&OutputGradient[i], m_ObjectGradient[i], m_RotateMatrix);
	}


	//Z\[g(VertexZlɂĕבւBB
	//Pȑ}\[g@gpA
	//̂ylׂĂȂ蔲dli
	for(i=1 ; i < m_ObjectPolyCount ; i++)
	{
		j=i;
		while(j >= 1 && OutputVertex[ m_ObjectPoly[j-1].iVIndex[0]].fZ > 
				OutputVertex[ m_ObjectPoly[j].iVIndex[0]].fZ)
		{
			PORY3 pTemp     = m_ObjectPoly[j];
			m_ObjectPoly[j]   = m_ObjectPoly[j-1];
			m_ObjectPoly[j-1] = pTemp;
			j--;
		}
	}


		RenderEngine.Render( OutputVertex,
							OutputGradient,
							m_ObjectVertexCount,
							m_ObjectPoly,
							m_ObjectPolyCount
						);

	delete [] OutputVertex;
	delete [] OutputGradient;
}
