#ifndef _OBJECTER
#define _OBJECTER
//=========================================================================
//IuWFN^[
//]Ƃz
//Ƃ肠A
//=========================================================================

#include "3dmath.h"
#include "settings.h"
#include "render.h"

class CObjecter
{

	public :
		CObjecter();
		~CObjecter();
		void MakeObject(C_VECTOR3 *lpvVertex, C_VECTOR3 *lpvGradient,
			int iVertexCount, C_PORY3 *lpiPoly, int iPolygonCount);

		void Rotate(float Head, float Pich, float Bank);
		void Render(CRender &RenderEngine);

	private:
		C3dmath Vcalk;

		VECTOR3 *m_ObjectVertex; 
		VECTOR3 *m_ObjectGradient;
		PORY3   *m_ObjectPoly;

		int m_ObjectVertexCount;
		int m_ObjectPolyCount;

		MATRIX33 m_RotateMatrix;

		BOOL m_MakeObjectFlag;
};

////////////////////////
#endif
