#include "render.h"
//======================================================================
//
//	CRender:_[
//		_Ƃ@󂯂ƂăfBXvCɃ_O܂B
//		݁Ae`惂[hmin/m_maxobt@\zR[h
//		Ă܂BėpɂĂǂB
//
//======================================================================

#include "misc.h"

//=================RXgN^
CRender :: CRender()
{
	//ݒ

	//=================ʒu
	m_Vcalk.VectorSet(m_Speclam, 1,1,1);
	m_Vcalk.VectorNormalize(m_Speclam);

	//=================_ʒu
	m_Vcalk.VectorSet(m_EyeGrad, 0, 0, 1);
	m_Vcalk.VectorNormalize(m_EyeGrad);

	//=================s
	m_Vcalk.VectorSet(Material, 128,255,128);
	//=================
	Ambient = 64;

	m_RenderMode = ENVRONMENT;

	m_psiScreenPbits = NULL;
	m_SetDisplayFlag = FALSE;
}
//===================fXgN^
CRender :: ~CRender()
{

	if(m_SetDisplayFlag)
	{
		delete [] m_max;
		delete [] m_min;
		delete [] m_cmin;
		delete [] m_cmax;

		delete [] m_umin;
		delete [] m_umax;
		delete [] m_vmin;
		delete [] m_vmax;
	}
}
//===================================================================
//
//	SetDispley:fBXvCZbg
//		PɃXN[̃sNZ|C^nĂ邾B
//		_̈̂łɕ܂A
//		ƁAɂgėlXȃp^Zbg邽
//	F
//		psiScreen	fBXvC̃sNZ
//		psiEnvTex	eNX`ṽsNZ
//		inWidth 	fBXvC̕
//		inHeight	fBXvC̍
//
//===================================================================
void CRender :: SetDispley(short int *psiScreen, short int *psiEnvTex, int inWidth, int inHeight)
{
	if(m_SetDisplayFlag)return;

	m_psiScreenPbits = psiScreen;
	m_psiEnvTexture = psiEnvTex;

	m_DispWidth = inWidth;
	m_DispHeight = inHeight;

	m_max = new int[m_DispHeight];
	m_min = new int[m_DispHeight];
	m_cmin = new float[m_DispHeight];
	m_cmax = new float[m_DispHeight];

	m_umin = new int[m_DispHeight];
	m_umax = new int[m_DispHeight];
	m_vmin = new int[m_DispHeight];
	m_vmax = new int[m_DispHeight];

	m_SetDisplayFlag = TRUE;
}
//===================================================================
//
//	Render:ΌnɂȂĂ钸_Ɩ@ɂ
//		|S`悵܂B̂ȂĂ邩Ƃ
//		DrawPrimitiveƂ3DANZ[^ւ̑Ή̈
//
//	F
//		lpvVertex   	_z
//		lpvGradient 	@z
//		iVertexCount	_̐
//		lpiPoly     	|Szi_ւ̃CfbNXj
//		iPolygonCount	|S̐
//
//===================================================================
BOOL CRender :: Render(C_VECTOR3 *lpvVertex, C_VECTOR3 *lpvGradient,
	int iVertexCount, C_PORY3 *lpiPoly, int iPolygonCount)
{

	//fBXvCݒ肵ĂȂ琳ɔ
	if(!m_psiScreenPbits)return FALSE;

	VECTOR3 Grad;//Aʏ@

	for(int i=0 ; i < iPolygonCount ; i++)
	{

		//AʏAIuWFNg̖@狁߂ƃO[p
		//߂Ăꍇ̂Ń|狁߂ďB
		{
			VECTOR3 vTmp1, vTmp2;
			m_Vcalk.VectorSub(vTmp1,lpvVertex[ lpiPoly[i].iVIndex[1] ],
								lpvVertex[ lpiPoly[i].iVIndex[0] ]);
			m_Vcalk.VectorSub(vTmp2,lpvVertex[ lpiPoly[i].iVIndex[1] ],
								lpvVertex[ lpiPoly[i].iVIndex[2] ]);
			m_Vcalk.VectorCross(Grad, vTmp1, vTmp2);
			m_Vcalk.VectorNormalize(Grad);
			float tmp = m_Vcalk.VectorDot(m_EyeGrad, Grad);
			if(tmp < 0)continue;//|폜
		}

		//ϊłiXN[TCYŒi΁jj
		POINT pPory[3];
		for(int j=0 ; j < 3 ;j++)
		{
			float dx3D = lpvVertex[ lpiPoly[i].iVIndex[j] ].fX;;
			float dy3D = lpvVertex[ lpiPoly[i].iVIndex[j] ].fY;;
			float dz3D = lpvVertex[ lpiPoly[i].iVIndex[j] ].fZ - (m_DispHeight);

			int dx2D = m_Vcalk.FloatToInt((dx3D * m_DispWidth) / dz3D);
			int dy2D = m_Vcalk.FloatToInt((dy3D * m_DispWidth) / dz3D);

			pPory[j].x = dx2D+(m_DispWidth/2);
			pPory[j].y = dy2D+(m_DispHeight/2);

		}

		//_Öׂɖ@i[
		VECTOR3 SmoothGrad[3];
		SmoothGrad[0] = lpvGradient[ lpiPoly[i].iVIndex[0] ];
		SmoothGrad[1] = lpvGradient[ lpiPoly[i].iVIndex[1] ];
		SmoothGrad[2] = lpvGradient[ lpiPoly[i].iVIndex[2] ];

		//_O
		switch(m_RenderMode)
		{
			case ENVRONMENT://eNX`

				EnvronmentMap(pPory, SmoothGrad, m_psiEnvTexture);

			break;

			case SMOOTHSHADE://O[VFCh

				SmoothShade(pPory, SmoothGrad);

			break;
			case FLATSHADE://tbgVFCh

				FlatShade(pPory, Grad);

			break;
			case WIREDFREAM://C[t[

				WiredFream(pPory);

			break;
		}

	}

return TRUE;
}

//================ȉAe_O֐=====================//

//==============================================================
//
//	WiredFream:C[t[
//
//	F
//		point	XN[̂Q֕ϊꂽ_z(X,Y)
//
//==============================================================

//R[ĥŌŐ̗]nA

void CRender :: WiredFream(const POINT *point)
{

	int i;
	POINT Dest[4];

	for(i=0 ; i<3 ; i++)
	{
		Dest[i] = point[i];
	}
	Dest[i] = point[0];

	int iColor = m_Vcalk.SetColor16(255,255,255);

	for(i=0 ; i<3 ; i++)
	{
		int x1 = Dest[i].x;
		int y1 = Dest[i].y;
		int x2 = Dest[i+1].x;
		int y2 = Dest[i+1].y;


	  //Sɉʂ̊OɂΏI
		if( ((y1<0) && (y2<0)) || ((y1>m_DispHeight-1) && (y2>m_DispHeight-1)) ) continue;


		int from, fin, now, fixedpoint; 
		int delta; 

		if(abs(x1-x2) > abs(y1-y2))
		{

			// `(cAntiAlias) 
			delta = (int)(((double)y2-y1)/((double)x2-x1)*65536.0);
			from  = x1;//
			fin   = x2;//
			fixedpoint = y1*65536; // 16:16̌Œ菬 //

			//for( now=from to fin do )
			for( now=from ; now <= fin ; now++ )
			{
				//PutPixel(now,fixedpoint >> 16, color, (fixedpoint & $FFFF)>> 8); // Ō͓̈x
				//PutPixel(now,(fixedpoint >> 16)+1, color, 255 - (fixedpoint & $FFFF)>> 8);

				int dx = now;
				int dy = fixedpoint >> 16;
				if( dx >= 0 && dx < WINDX && dy >= 0 && dy < WINDY )
				{
					m_psiScreenPbits[dx+ dy*m_DispWidth] = iColor;
				}

				fixedpoint = fixedpoint + delta; 
			}

		}else{

			// c`(AntiAlias) 
			delta = (int)(((double)x2-x1)/((double)y2-y1)*65536.0);
			from  = y1;
			fin   = y2;
			fixedpoint = x1*65536;

			//for( now=from to fin do )
			for( now=from ; now <= fin ; now++)
			{
				//PutPixel(fixedpoint >> 16, now, color, (fixedpoint & $FFFF)>> 8);
				//PutPixel((fixedpoint >> 16)+1, now, color, 255 - (fixedpoint & $FFFF)>> 8);

				int dx = fixedpoint >> 16;
				int dy = now;
				if( dx >= 0 && dx < WINDX && dy >= 0 && dy < WINDY )
				{
					m_psiScreenPbits[dx+ dy*m_DispWidth] = iColor;
				}

				fixedpoint = fixedpoint + delta; 
			}

		}
	}
}
//==============================================================
//
//	 FlatShade:tbgVFCh
//
//	F
//		point	XN[̂Q֕ϊꂽ_z(X,Y)
//		vGrad	VFChp@
//
//==============================================================

void CRender :: FlatShade(const POINT *point, VECTOR3 vGrad)
{
	//min/max
	for( int i=0 ; i < m_DispHeight ; i++ )
	{
		m_min[i] = 32767;
		m_max[i] = -32768;
	}

	//min/maxobt@\z
	ScanLine( point[0].x, point[0].y, point[1].x, point[1].y);
	ScanLine( point[1].x, point[1].y, point[2].x, point[2].y);
	ScanLine( point[2].x, point[2].y, point[0].x, point[0].y);


	//tbgpF
	float tmp = m_Vcalk.VectorDot(m_Speclam, vGrad);
	if(tmp < 0)tmp = 0;

	//VF[hF
	int r = m_Vcalk.FloatToInt(Ambient + Material.fR*tmp);
	int g = m_Vcalk.FloatToInt(Ambient + Material.fG*tmp);
	int b = m_Vcalk.FloatToInt(Ambient + Material.fB*tmp);

	if(r > 255)r=255;//AȂBiGG
	if(g > 255)g=255;
	if(b > 255)b=255;

	int iColor = m_Vcalk.SetColor16(r,g,b);

	//ʃrbg擾
	short int *pBits = m_psiScreenPbits;

	//y[v
	for( int py = 0 ; py < m_DispHeight ; py++)
	{

		short int *pPix = pBits;
		if( (m_min[py] <  m_DispWidth) && (m_max[py] >  0) )
		{
			int px = m_min[py];
			int pz = m_max[py];

			if( px < 0 ) px = 0;
			if( pz > m_DispWidth-1) pz = m_DispWidth-1;

			pPix += px;

			//X[v
			for(i=0 ; i < pz-px ; i++)
			{
				pPix[i] = iColor;
			}
		}

		pBits += m_DispWidth;
	}


}
//===============tbgVFChpőŏobt@\z
void CRender :: ScanLine(int x1,int y1,int x2,int y2)
{
	int  x,y,dx,tx;

  //Sɉʂ̊OɂΏI
	if( ((y1<0) && (y2<0)) || ((y1>m_DispHeight-1) && (y2>m_DispHeight-1)) ) return;

	if( y1 == y2 )
	{
		if(m_min[y1] > x1) m_min[y1] = x1;
		if(m_max[y1] < x1) m_max[y1] = x1;
		if(m_min[y1] > x2) m_min[y1] = x2;
		if(m_max[y1] < x2) m_max[y1] = x2;
	}
	else
	{
		if( y1 > y2)
		{
			m_Vcalk.Swap(x1,x2);//ւ
			m_Vcalk.Swap(y1,y2);
		}

		x = (x1 << 16);//ՎŒ菬_
	    dx = ((x2-x1) << 16) / (y2-y1);

		for( y = y1 ; y <= y2 ; y++)
		{
			if( (y>=0) && (y<m_DispHeight) )
			{
				tx = x >> 16;
				if(m_min[y] > tx) m_min[y] = tx;
				if(m_max[y] < tx) m_max[y] = tx;
			}
			x += dx;
		}
	}

}
//==============================================================
//
//	 SmoothShade:X[YVFCh
//
//	F
//		point	XN[̂Q֕ϊꂽ_z(X,Y)
//		vGrad	VFChp@
//
//==============================================================
void CRender :: SmoothShade(const POINT *point, C_VECTOR3* vGrad)
{
	int i;

	//min/maxobt@
	for(i=0 ; i < m_DispHeight ; i++ )
	{
		m_min[i] = 32767;
		m_max[i] = -32768;
	}

	//VF[hpXyNg
	float fShade[3];
	for(i=0 ; i < 3 ; i++)
	{
		fShade[i] = m_Vcalk.VectorDot(m_Speclam, vGrad[i]);
		if(fShade[i] < 0)fShade[i] = 0;
	}

	//min/maxobt@\z
	ScanLine( point[0].x, point[0].y, fShade[0], point[1].x, point[1].y, fShade[1]);
	ScanLine( point[1].x, point[1].y, fShade[1], point[2].x, point[2].y, fShade[2]);
	ScanLine( point[2].x, point[2].y, fShade[2], point[0].x, point[0].y, fShade[0]);

	//ʃrbg擾
	short int *pBits = m_psiScreenPbits;

	//y[v
	for( int py = 0 ; py < m_DispHeight ; py++)
	{

		short int *pPix = pBits;

		if( (m_min[py] <  m_DispWidth) && (m_max[py] >  0) )
		{
			int px = m_min[py];//W
			int pz = m_max[py];
			float cx = m_cmin[py];//F
			float cz = m_cmax[py];

			pPix += px;

			int iLineWidth = pz-px;//XLC

			float ColDest = (cz - cx)/iLineWidth;
			float fCol = cx;

			//X[v
			for(i=0 ; i < iLineWidth ; i++)
			{
				//VF[hF
				int r = m_Vcalk.FloatToInt(Ambient + Material.fR * fCol);//F
				int g = m_Vcalk.FloatToInt(Ambient + Material.fG * fCol);
				int b = m_Vcalk.FloatToInt(Ambient + Material.fB * fCol);

				if(r > 255) r = 255;//Ȃ[O
				if(g > 255) g = 255;
				if(b > 255) b = 255;

				int iColor = m_Vcalk.SetColor16(r, g, b);

				pPix[i] = iColor;
				fCol += ColDest;
			}
		}
		pBits += m_DispWidth;
	}

}
//=============X[YVFChpőŏobt@\z
void CRender :: ScanLine(int x1,int y1, float c1, int x2,int y2, float c2)
{

  //Sɉʂ̊OɂΏI
	if( ((y1<0) && (y2<0)) || ((y1>m_DispHeight-1) && (y2>m_DispHeight-1)) ) return;

	if( y1 == y2 )
	{
		if(m_min[y1] > x1)
		{
			m_min[y1] = x1;
			m_cmin[y1] = c1;
		}
		if(m_max[y1] < x1)
		{
			m_max[y1] = x1;
			m_cmax[y1] = c1;
		}
		if(m_min[y1] > x2)
		{
			m_min[y1] = x2;
			m_cmin[y1] = c2;
		}
		if(m_max[y1] < x2)
		{
			m_max[y1] = x2;
			m_cmax[y1] = c2;
		}
	}
	else
	{
		if( y1 > y2)
		{
			m_Vcalk.Swap(x1,x2);//ւ
			m_Vcalk.Swap(y1,y2);
			m_Vcalk.Swap(c1,c2);
		}

		int x = (x1 << 16);//ՎŒ菬_
	    int dx = ((x2-x1) << 16) / (y2-y1);//wZ

		float fCol = c1;
		float fDestCol = (c2-c1) / (y2-y1);//Z

		for(int y = y1 ; y <= y2 ; y++)
		{
			if( (y>=0) && (y<m_DispHeight) )
			{
				int tx = x >> 16;
				if(m_min[y] > tx){
					m_min[y] = tx;
					m_cmin[y] = fCol;
				}
				if(m_max[y] < tx){
					m_max[y] = tx;
					m_cmax[y] = fCol;
				}
			}
			x += dx;
			fCol += fDestCol;
		}
	}

}
//==============================================================
//
//	 SmoothShade:}bsO
//
//	F
//		point	XN[̂Q֕ϊꂽ_z(X,Y)
//		vGrad	VFChp@
//		psiEnvBits	eNX`̃rbg
//
//==============================================================
void CRender :: EnvronmentMap(const POINT *point, C_VECTOR3* vGrad, C_SINT * psiEnvBits)
{
	short int * pLine, *pPix;
	int x,y,u,v,um,vm,i;

	//őŏobt@̃Zbg
	for( i=0 ; i< m_DispHeight ;i++)
	{
		m_min[i] = 32767;
		m_max[i] = -32768;
	}

	//eNX`ʒu߁A@ɂĈړ(256*256eNX`Œj
	int envU[3];
	int envV[3];
	for(i=0 ; i<3 ; i++)
	{
		envU[i] = 127 + m_Vcalk.FloatToInt(128 * vGrad[i].fX);
		envV[i] = 127 + m_Vcalk.FloatToInt(128 * vGrad[i].fY);
	}

	//min/maxobt@\z
	ScanLine( point[0].x, point[0].y, point[1].x, point[1].y,
				envU[0], envV[0], envU[1], envV[1]);

	ScanLine( point[1].x, point[1].y, point[2].x, point[2].y,
				envU[1], envV[1], envU[2], envV[2]);

	ScanLine( point[2].x, point[2].y, point[0].x, point[0].y,
				envU[2], envV[2], envU[0], envV[0]);

	//ʃrbg擾
	pLine = m_psiScreenPbits;

	//y[v
	for( y=0 ; y < m_DispHeight ; y++)
	{

		if( m_min[y] < 32767 )
		{
			um = ((m_umax[y] - m_umin[y]) << 16) / (m_max[y] - m_min[y]+1);
			vm = ((m_vmax[y] - m_vmin[y]) << 16) / (m_max[y] - m_min[y]+1);
			u = m_umin[y] << 16;
			v = m_vmin[y] << 16;
			pPix = pLine;

			if( (m_min[y] < m_DispWidth) && (m_max[y] >= 0) )
			{
				if( m_max[y]>m_DispWidth-1 ) m_max[y] = m_DispWidth-1;
				if( m_min[y]>0   ) pPix += m_min[y];

				//x[v
				for( x = m_min[y] ; x < m_max[y] ; x++)
				{
					*pPix = psiEnvBits[((u>>16)&0xFF) + ((v>>8)&0xFF00)];
					u = u+um;
					v = v+vm;
					if( x > 0 )pPix++;
				}
			}
		}
		pLine += m_DispWidth;
	}

}
//========================eNX`pőŏobt@\z
void CRender :: ScanLine(int x1, int y1, int x2, int y2, 
		int u1, int v1, int u2, int v2)
{
	int xm,um,vm,x,y,u,v,tx;

	if( ((y1< 0) && (y2< 0)) || ((y1>m_DispHeight-1) && (y2>m_DispHeight-1)) )return;

	if( y1 == y2 )
	{
		if( m_min[y1] > x1 )
		{
			m_min[y1]  = x1;
			m_umin[y1] = u1;
			m_vmin[y1] = v1;
		}

		if( m_max[y1] < x1)
		{
			m_max[y1] =  x1;
			m_umax[y1] = u1;
			m_vmax[y1] = v1;
		}

		if( m_min[y1] > x2 )
		{
			m_min[y1] = x2;
			m_umin[y1] = u2;
			m_umin[y1] = v2;
		};

		if( m_max[y1] < x2 )
		{
			m_max[y1]  = x2;
			m_umax[y1] = u2;
			m_vmax[y1] = v2;
		};
	}else{

		if( y1 > y2 )
		{
			m_Vcalk.Swap(x1,x2);
			m_Vcalk.Swap(y1,y2);
			m_Vcalk.Swap(u1,u2);
			m_Vcalk.Swap(v1,v2);
		}

		xm = ((x2-x1) << 16) / (y2-y1);
		um = ((u2-u1) << 16) / (y2-y1);
		vm = ((v2-v1) << 16) / (y2-y1);
		x = x1 << 16;
		u = u1 << 16;
		v = v1 << 16;

		 for( y = y1 ; y < y2 ;y++)
		 {

			if( (y>=0) && (y<m_DispHeight) )
			{
				tx = x / 65536; //x͕l̉\̂ div g

				if( m_min[y] > tx)
				{
					m_min[y] = tx;
					m_umin[y] = u >> 16;
					m_vmin[y] = v >> 16;
				}

				if( m_max[y] < tx )
				{
					m_max[y] = tx;
					m_umax[y] = u >> 16;
					m_vmax[y] = v >> 16;
				}
			}
			x = x+xm;
			u = u+um;
			v = v+vm;
		}
	}

}
