///////////////////////////////////////////////////////////////////////////////

//  Array3D.h

//  Coder.Yudai Senoo :-)

//X}APȂŃ\[X邮炢ς̗]n
//̂܂܎gĂ܂ 
//by Tya-pa- :P

#ifndef __ARRAY3D__
#define __ARRAY3D__

#include <windows.h>
#include "misc.h"

template <class T> class CArray3D {
	T***	pptAry;
	int		nX, nY, nZ;

public:
	CArray3D(void);
	~CArray3D();

	// Zq̃I[o[[h
	operator T***() { return pptAry; };
	bool	Alloc(int z, int y, int x);		// zp̃m

	void	Free(void);						// zp̃
	void	SetFillElement(T a);		// SĂ̗vfɎwf[^

	// 擾o֐
	int		GetX(void) { return nX; }					// x擾
	int		GetY(void) { return nY; }					// y擾
	int		GetZ(void) { return nZ; }					// z擾
	T*		GetPointer(int z, int y, int x) { return &pptAry[z][y][x]; }	// w肳ꂽʒuւ̃|C^擾

};

template <class T> CArray3D<T>::CArray3D(void)
{
	nX	= 0;
	nY	= 0;
	nZ	= 0;

	pptAry = NULL;

}

template <class T> CArray3D<T>::~CArray3D()
{
	if (pptAry != NULL) {
		if (pptAry[0] != NULL) delete[] pptAry[0];
		delete[] pptAry;
		pptAry = NULL;
	}

}

template <class T> bool CArray3D<T>::Alloc(int z, int y, int x)
{
	if (z == 0 || y == 0 || x == 0) {
#ifdef _DEBUG
		OutErrMessage(NULL, NULL, "CArray3D<T>::Alloc ŃTCYOw肳܂");
#endif
		return false;
	}
	if (pptAry != NULL) return false;	// ɃmۂĂ

	nX = x;
	nY = y;
	nZ = z;

	pptAry = new T**[z];
	if (pptAry == NULL) {
#ifdef _DEBUG
		OutErrMessage(NULL, NULL, "CArray3D<T>ŃmۂɎs܂");
#endif
		return false;
	}

	pptAry[0] = new T*[z * y];
	if (pptAry[0] == NULL) {
#ifdef _DEBUG
		OutErrMessage(NULL, NULL, "CArray3D<T>ŃmۂɎs܂");
#endif
		delete[] pptAry;
		pptAry = NULL;
		return false;
	}

	for (int i = 1; i < z; i++)
		pptAry[i] = pptAry[0] + i * y;

	pptAry[0][0] = new T[z * y * x];
	if (pptAry[0][0] == NULL) {
#ifdef _DEBUG
		OutErrMessage(NULL, NULL, "CArray3D<T>ŃmۂɎs܂");
#endif
		delete[] pptAry[0];
		delete[] pptAry;
		pptAry = NULL;
		return false;
	}

	for (i = 0; i < z; i++) {
		for (int j = 0; j < y; j++) {
			pptAry[i][j] = pptAry[0][0] + j * x + i * (x * y);
		}
	}

	return true;

}

template <class T> void CArray3D<T>::Free(void)
{
	if (pptAry != NULL) {
		if (pptAry[0] != NULL) {
			if (pptAry[0][0] != NULL) delete[] pptAry[0][0];
			delete[] pptAry[0];
		}
		delete[] pptAry;
	}

	pptAry = NULL;
	nX = 0;
	nY = 0;
	nZ = 0;

}

template <class T> void CArray3D<T>::SetFillElement(T a)
{
	for (int z = 0; z < nZ; z++) {
		for (int y = 0; y < nY; y++) {
			for (int x = 0; x < nX; x++)
				pptAry[z][y][x] = a;
		}
	}

}

#endif // __ARRAY3D__
