#include "gseeker.h"
//=========================================================================
//
//	GridSeeker:ObhV[J[
//		ꂽ]Bef[^[
//		dʋԂɔZxz`
//		MurchCubep
//
//=========================================================================


CGseek :: CGseek(CMainWindow* mainwin)
{
	m_main = mainwin;
}
CGseek :: ~CGseek()
{

}
void CGseek :: SetUP( int iFreamStep, int GridDiv, int VideoXSize, int VideoYSize)
{
	CMcube::SetCubeSpace(
				VideoXSize/(GridDiv*2),
				VideoYSize/GridDiv,
				iFreamStep,
				GridDiv
			);

	m_Vwidth  = VideoXSize;
	m_Vheight = VideoYSize;
	m_FreamStep = iFreamStep;

}
BOOL CGseek :: GridSeek(const BYTE *pBits, int NowStep)
{
	//ɍWΉ

	int CenterGridX = CMcube::m_XDIV/2;
	int CenterGridY = CMcube::m_YDIV/2;
	int CenterGridZ = CMcube::m_ZDIV/2;

	for(int GridY = 0 ; GridY < CMcube::m_YDIV ; GridY++)
	{
		for(int GridX = 0 ; GridX < CMcube::m_XDIV ; GridX++)
		{
			int bitsXpos = (GridX * CMcube::m_GRID_SIZE) + (m_Vwidth/2);
			int bitsYpos = GridY * CMcube::m_GRID_SIZE;

			//⊮ɕKvȃsNZ̊肾
			BYTE NowPixsel;
			if(bitsXpos <= m_Vwidth && bitsXpos >= 0 )
			{
				NowPixsel  = GetAverge(bitsXpos*3 + bitsYpos * m_Vwidth*3, pBits);
			}else{
				NowPixsel  = 0;
			}

			 CMcube::m_fDisp[NowStep][GridY][GridX] = NowPixsel;
			CMcube::m_blFlag[NowStep][GridY][GridX] = NowPixsel > ISO;

		}

	}


	return TRUE;
}
BOOL CGseek :: bulid()
{
	CMcube :: MarchCube();

	return TRUE;
}

//e|甒J[Ԃ
BYTE CGseek :: GetAverge(int bitsPos, const BYTE *Bits)
{
	const BYTE *color = &Bits[bitsPos];

	return (  (*color + (*(color+1)) + (*(color+2)) ) /3 );

}
