#include "Mcube.h"
//=========================================================================
//
//	Blobs:}[`L[uNX
//		dʋԂɋ̔Zxz`
//		}[`L[uASYg
//		̉B
//
//		Ȃ݂Ƀ_OglɂrɂȂ񂮂炢
//		xAȏ㍂ɂ́A}[`L[uԂ
//		Wn|Zŋ߂Ă̂ŁAIC[Ƀϊ
//		Zŋ߂̂gB
//		łƃ\[XǂݎȂ񂾂˂DD
//		by tya-pa-
//
//=========================================================================

#include "marchTBL.h"

//=====================AC\ilj
C_FLOAT CMcube :: ISO = 192;

//=====================RXgN^
CMcube :: CMcube()
{
	m_Vcalk.InitSinTable();

	m_blSetupFlag = FALSE;

	//|C^
	m_VertexList     = 0;
	m_vGradient      = 0;
	m_iVertexCounter = 0;
	m_Poly           = 0;
	m_iPoryCounter   = 0;
}
CMcube :: ~CMcube()
{
	if(m_blSetupFlag)
	{
		delete [] m_VertexList;
		delete [] m_vGradient;
		delete [] m_Poly;
		 m_fDisp.Free();
		m_blFlag.Free();
	}
}

//=======================}[`L[uԂ̐ݒ
void CMcube :: SetCubeSpace(int iXdiv, int iYdiv, int iZdiv, int iGridSize)
{
	if(m_blSetupFlag)
	{
		delete [] m_VertexList;
		delete [] m_vGradient;
		delete [] m_Poly;
		 m_fDisp.Free();
		m_blFlag.Free();
	}

	//ȊO͂X,Y,ZDIV͒萔ƂĈ
	m_XDIV = iXdiv;	//Ԃ̉̑傫
	m_YDIV = iYdiv;	//Ԃ̏c̑傫
	m_ZDIV = iZdiv;	//Ԃ̉s
	m_GRID_SIZE = iGridSize;	//Obhi؂j̊Ԋu
	//XDIV * GRIDSIZE = Ԃ̎ۂ̑̕傫isNZj


	//eAObh̃}[`L[uԂ
	//ImۂĎgpĂ܂B
	m_VertexList = new VECTOR3[m_ZDIV * m_YDIV * m_XDIV * 3];
	m_vGradient  = new VECTOR3[m_ZDIV * m_YDIV * m_XDIV * 3];
	m_Poly       = new   PORY3[m_ZDIV * m_YDIV * m_XDIV * 3];

	 m_fDisp.Alloc(m_ZDIV, m_YDIV, m_XDIV);   //MarchCubeԂ̔Zx\
	m_blFlag.Alloc(m_ZDIV, m_YDIV, m_XDIV);//~lȏ̒_tO

	m_fDisp.SetFillElement(0);
	m_blFlag.SetFillElement(FALSE);

	m_blSetupFlag = TRUE;
}

//=========================================================================
//
//	MarchCube:}[`L[u
//		̓dʂ̎ZoA|\zsȂB
//
//=========================================================================
BOOL CMcube :: MarchCube()
{
	if(!m_blSetupFlag)return FALSE;

	int   nx,ny,nz,i;
	int CZ = m_ZDIV/2;
	int CY = m_YDIV/2;
	int CX = m_XDIV/2;

	CArray3D<VECTOR3> fVertex;
		fVertex.Alloc(m_ZDIV, m_YDIV, m_XDIV);


	//@ZbgĂ
	for ( nz=0; nz<m_ZDIV ; nz++ )
	{
		for ( ny=0 ; ny<m_YDIV ; ny++ )
		{
			for ( nx=0 ; nx<m_XDIV ; nx++ )
			{
				float dx = nx * m_GRID_SIZE - m_XDIV * m_GRID_SIZE /2.0f; 
				float dy = ny * m_GRID_SIZE - m_YDIV * m_GRID_SIZE /2.0f; 
				float dz = nz * m_GRID_SIZE - m_ZDIV * m_GRID_SIZE /2.0f; 

				//xNg߂ ̉Ẑ sqrt͊OĂ
				float fDistance = dx*dx + dy*dy + dz*dz;

				//Obh̒S̖@xNgłB
				//ʏÂ͒Ɉʒû
				fVertex[nz][ny][nx].fX = dx/fDistance;
				fVertex[nz][ny][nx].fY = dy/fDistance;
				fVertex[nz][ny][nx].fZ = dz/fDistance;

			}
		}
	}

/*
	/////////////////////////////////////////////////////////////////
	//	mFR[h
	//		}[`L[uɏo͂邩`FbN邽߂̂
	//		Ȃ݂ɂ͒SɁAsizeObh̉~`
	/////////////////////////////////////////////////////////////////
	{
		int SIZE = 5;
		for ( nz=0 ; nz<ZDIV ; nz++ )
		{
			for ( ny=CY-SIZE ; ny<CY+SIZE ; ny++ )
			{
				for ( nx=0 ; nx<SIZE ; nx++ )
				{
					 m_fDisp[nz][ny][nx] = 128;
					m_blFlag[nz][ny][nx] = 128 > ISO;
				}
			}
		}
	}
*/

//==========================================================================
//AdaptiveMarchingCubes (Ksi)
	m_iPoryCounter = 0;
	m_iVertexCounter = 0;
	for ( nz=0; nz<m_ZDIV-1 ; nz++ )
	{
		for ( ny=0 ; ny<m_YDIV-1 ; ny++ )
		{
			for ( nx=0 ; nx<m_XDIV-1 ; nx++ )
			{

				//256̃P[X15Ɍ܂B
				int bIndex = 0;
				VECTOR3 vGrid[8];
				VECTOR3 vGrad[8];
				float fGridPow[8];

				//ӎQƃe[u쐬
				BYTE bTbl[8][3]={
						{0,0,0},{1,0,0},{1,1,0},{0,1,0},
						{0,0,1},{1,0,1},{1,1,1},{0,1,1}
					};

			//=======ȉObĥW̒_ŃL[uƂ݂Ȃ
			//========|S\z鉺
				for(i=0 ; i < 8 ; i++)
				{
					int ia = bTbl[i][0];
					int ib = bTbl[i][1];
					int ic = bTbl[i][2];

					//Obh̃L[ûW̒_Zo
					//ZXŋɍWȂĂ̂/sWւƕϊ
					//XYɑ΂Ă͒snȂ̂ŒKv͂Ȃ
					//vGrid[i].fX = (float)((nx+ia-CX) *  m_GRID_SIZE);
					//vGrid[i].fY = (float)((ny+ib-CY) *  m_GRID_SIZE);
					//vGrid[i].fZ = (float)((nz+ic-CZ) *  m_GRID_SIZE);

					double ZRad = (nz+ic) * ((M_PI*2) / (m_ZDIV-1));
					vGrid[i].fX = (float)(cos(ZRad) * (nx+ia) *  m_GRID_SIZE);
					vGrid[i].fY = (float)((ny+ib-CY) *  m_GRID_SIZE);
					vGrid[i].fZ = (float)(sin(ZRad) * (nx+ia) *  m_GRID_SIZE);

					//========_tOݒ
					if(m_blFlag[nz + ic][ny + ib][nx + ia]) bIndex |= (1<<i);
					//========L[ũAC\Eo
					fGridPow[i] = m_fDisp[nz + ic][ny + ib][nx + ia];
					//========L[u̒_̖@Eo
					vGrad[i] = fVertex[nz + ic][ny + ib][nx + ia];
				}
				if(edgeTable[bIndex]  == 0)continue;

//=============================_\z
//ő12Ȃ̂̓|S\ző吔4łˁA
//璸_3Ȃ̂3*4=12BȂ݂ɍŏ3
				int iTbl1[12] = {0,1,2,3,4,5,6,7,0,1,2,3};//Ӄe[uP
				int iTbl2[12] = {1,2,3,0,5,6,7,4,4,5,6,7};//Ӄe[uQ

				//==============Zoʒlꎞi[ϐ
				VECTOR3 vVert[12];
				VECTOR3 vVertNormal[12];

				for(i=0 ; i < 12 ; i++)
				{
					//(edgeTable[256] from marchTBL.h
					if(edgeTable[bIndex] & ( 1<<i ))
					{
						//Adaputive Vertex
						//ӂƕӂ̔ZxrĒ_o܂
						//łɖ@߂ႦI
							VertexInterp(ISO,
									vVert[i],//߂l
									vVertNormal[i],//߂l
									vGrid[ iTbl1[i] ],
									vGrid[ iTbl2[i] ],
									vGrad[ iTbl1[i] ],
									vGrad[ iTbl2[i] ],
									fGridPow[ iTbl1[i] ],
									fGridPow[ iTbl2[i] ]
								);
					}
				}

			//=======================@A_A|S̊i[
				//triTable[256*16]̂łe[u(marchTBL.h)́A
				//_Xgւ̃CfbNXĂ܂B
				//|S͈Ă̒A_ւ̃CfbNXl݂̂܂B
				for (i=0 ; triTable[bIndex][i] != 255 ; i+=3)
				{
					//_
					m_VertexList[m_iVertexCounter  ] = vVert[triTable[bIndex][i  ]];
					m_VertexList[m_iVertexCounter+1] = vVert[triTable[bIndex][i+1]];
					m_VertexList[m_iVertexCounter+2] = vVert[triTable[bIndex][i+2]];

					//@
					m_vGradient[m_iVertexCounter  ] = vVertNormal[triTable[bIndex][i  ]];
					m_vGradient[m_iVertexCounter+1] = vVertNormal[triTable[bIndex][i+1]];
					m_vGradient[m_iVertexCounter+2] = vVertNormal[triTable[bIndex][i+2]];

					//|
					m_Poly[m_iPoryCounter].iVIndex[0] = m_iVertexCounter;
					m_Poly[m_iPoryCounter].iVIndex[1] = m_iVertexCounter+1;
					m_Poly[m_iPoryCounter].iVIndex[2] = m_iVertexCounter+2;

					m_iPoryCounter++;
					m_iVertexCounter += 3;
				}
			}
		}
	}

	//gIYꂸɏ܂傤B
	fVertex.Free();

return TRUE;
}
//===============================================================
//	VertexInterpF
//		ӂƕӂrVertexi_HjAdaptiveiKHj܂B
//===============================================================
//AC\(iso)  l
void  CMcube :: VertexInterp( 
	C_FLOAT isolevel,	//l̔Zxx
	VECTOR3 &vVect,		//Kꂽ_o
	VECTOR3 &vNormal,	//o
	C_VECTOR3 &p1,		//̂̕
	C_VECTOR3 &p2,
	C_VECTOR3 &v1,		//̖̂@
	C_VECTOR3 &v2,
	C_FLOAT valp1,		//̂̕ӂ̔Zx
	C_FLOAT valp2)
	//炯DĎ`
{

	float mul;

	mul = (isolevel - valp1) / (valp2 - valp1);

	//L[u̒_AC\ɂ
	//XCh|SɎg_߂B
	vVect.fX = p1.fX + mul * (p2.fX - p1.fX);
	vVect.fY = p1.fY + mul * (p2.fY - p1.fY);
	vVect.fZ = p1.fZ + mul * (p2.fZ - p1.fZ);

	//͖@
	vNormal.fX = v1.fX + mul * (v2.fX - v1.fX);
	vNormal.fY = v1.fY + mul * (v2.fY - v1.fY);
	vNormal.fZ = v1.fZ + mul * (v2.fZ - v1.fZ);

	m_Vcalk.VectorNormalize( vNormal );

}
